
/*******************************************************************************

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

 Copyright (C) 2011 Nuno Fortes(nunofort@gmail.com)

FILE: CommandAction.hpp

DESC: Command Type Alert Action

********************************************************************************/


#ifndef COMMANDACTION_CLASS
#define COMMANDACTION_CLASS

#include <c++/version/string>
#include <c++/version/sstream>
#include <c++/version/iostream>

using namespace std;

//extern "C++" {
#include "Action.hpp"
//}

//Command Type Alert Action

class CommandAction : public Action {
public:
CommandAction();
~ CommandAction() {}
CommandAction(std::string cmd);
//void addMatch(std::string match);
std::string get();
void execute(Expression *ex);
void simulate(bool sim);


private:
std::string exec;

//std::vector<std::string> matches;


};



CommandAction::CommandAction() {}

CommandAction::CommandAction(std::string cmd) 
{
  s = cmd; 
  exec = cmd;
}

std::string CommandAction::get() {
return exec;
}

/*
void CommandAction::addMatch(std::string match) {
matches.push_back(match);
}
*/

void CommandAction::execute(Expression *ex) {
//cout << "PROCESS Action: " << exec << endl;
//cout << "REGEX MATCH: " << *ex << endl;

std::string cmd = exec;
//GET MATCHES FROM EXPRESSION!
if (ex->matches() >= 1) {
//cout << ex->matches() << endl;
for (int i = 0; i < ex->matches(); i++)
{
     std::string m = ex->getMatch(i);
     std::ostringstream o;
     o << "%" << i;
     Pcre s(o.str());
     cmd = s.replace(cmd,m);
     //cmd = cmd.replace(s,m);
     //cout << o.str() << "=[" << m << "]" << endl;
     //cout << "REPLACE: " << cmd << endl;
}
}

if (this->sim)
cout << "EXECUTE: " << cmd << endl;
else
system(cmd.c_str());


}

void CommandAction::simulate(bool sim) {
   this->sim = sim;
}

#endif

